#include "scdata.h"

const char 	*SC_wlset_name = "wl.set",
		*SC_worklogs_dir = "worklogs/",
		*SC_errorlog_name = "error.log";

const char* SCr_err_to_str(int type)
{
	static char buf[30];
	switch(type)
	{
		case SCr_err_startup : strcpy(buf, "Startup"); break;
		case SCr_err_nocheck : strcpy(buf, "SCs_nocheck"); break;
		case SCr_err_file_format : strcpy(buf, "File format"); break;
		case SCr_err_sys_disk : strcpy(buf, "System disk"); break;
		case SCr_err_transfer : strcpy(buf, "Transfer"); break;
		case SCr_err_unloged : strcpy(buf, "Unloged"); break;
	}

	return buf;
}

void scode_time(char* give, time_t timer)
{
	struct tm* tm_buf = localtime(&timer);
	strftime(give, 20, "%H:%M:%S", tm_buf);
}

void scode_date(char* give, time_t timer)
{
	struct tm* tm_buf = gmtime(&timer);
	strftime(give, 20, "%Y-%m-%d", tm_buf);
}

void SCr_err_fwrite(FILE* dst, const struct SCr_errno* err)
{
	fwrite(&(err->time), sizeof(time_t), 1, dst);
	fwrite(&(err->type), sizeof(int), 1, dst);
	fwrite(&(err->code), sizeof(int), 1, dst);
}

void SCr_err_fread(FILE* src, struct SCr_errno* err)
{
	fread(&(err->time), sizeof(time_t), 1, src);
	fread(&(err->type), sizeof(int), 1, src);
	fread(&(err->code), sizeof(int), 1, src);
}

int SCs_data_fwrite(FILE* dst, const struct SCs_data* data)
{
	if( fwrite(data, sizeof(struct SCs_data), 1, dst)
		== 1 )
		return 0;
	else
		return -1;
}

int SCs_data_fread(FILE* src, struct SCs_data* data)
{
	if( fread(data, sizeof(struct SCs_data), 1, src)
		== 1 )
		return 0;
	else
		return -1;
}

/* md5sum source mod */

int md5file(FILE *fp, unsigned char *digest)
{
	unsigned char buf[1024];
	MD5_CTX ctx;
	int n;

	MD5Init(&ctx);
	while ((n = fread(buf, 1, sizeof(buf), fp)) > 0)
		MD5Update(&ctx, buf, n);
	MD5Final(digest, &ctx);
	if (ferror(fp))
		return -1;
	return 0;
}


