#include "wlcstdio.h"



int copy(const char* src, const char* dst)
{
	FILE *fsrc, *fdst;
	const size_t bsize = 1024;
	void* buf = malloc(sizeof(unsigned char)*bsize);
	size_t bytes;

	fsrc = fopen(src, "rb");
	if(!fsrc)
		return -1;

	fdst = fopen(dst, "wb");
	if(!fdst)
	{
		fclose(fsrc);
		return -1;
	}
	
	while(!feof(fsrc))
	{
		bytes = fread(buf, sizeof(unsigned char), bsize, fsrc);
		fwrite(buf, sizeof(unsigned char), bytes, fdst);
	}

	fclose(fsrc);
	fclose(fdst);
	return 0;
}

int append(const char* src, const char* to)
{
	FILE *fsrc, *fto;
	const size_t bsize = 1024;
	void* buf = malloc(sizeof(unsigned char)*bsize);
	size_t bytes;
	
	fsrc = fopen(src, "rb");
	if(!fsrc)
		return -1;

	fto = fopen(to, "ab");
	if(!fto)
	{
		fclose(fsrc);
		return -1;
	}

	while(!feof(fsrc))
	{
		bytes = fread(buf, sizeof(unsigned char), bsize, fsrc);
		fwrite(buf, sizeof(unsigned char), bytes, fto);
	}

	fclose(fsrc);
	fclose(fto);
	return 0;
}

