/** @file wlcstdio.h
 * Extends the stdio.h library.
 */

#ifndef WLCSTDIO_H_
#define WLCSTDIO_H_

#include <stdlib.h>
#include <stdio.h>

/**
 * Separato/slash used in file and directory paths.
 */
#if defined(__WIN32)
	#define dir_sep '\\'
#elif defined(unix)
	#define dir_sep '/'
#else
	#warning "Unsaported OS, assuming dir_sep is \'/\'"
	#define dir_sep '/'
#endif
;

/**
 * Copys file from path src to path dst.
 * @param src source file path
 * @param dst destination file path
 * @return 0 if succesfull, -1 otherwise
 */
int copy(const char* src, const char* dst);

/**
 * Appends file from path src to the end of a file from path to.
 * @param src source file path
 * @param dst destination file path
 * @return 0 is succesfull, -1 otherwise
 */
int append(const char* src, const char* to);

#endif /* WLCSTDIO_H_ */
