/** @file wlcstdlib.h
 * Extends the stdlib.h library.
 */

#ifndef WLCSTDLIB_H_
#define WLCSTDLIB_H_

#include <stdlib.h>

typedef unsigned char byte; /**< byte type for binary operations */
typedef byte tiny_int; /**< for operations on very small integers */

/** 
 * Prints x to binary form up to the c bit.
 * @param x number to print
 * @param c number of bits to print
 * @return a pointer to the generated string
 */
char* itoab(int x, unsigned c);

/**
 * Converts binary number writen in string b to an integer
 * using n first bits.
 * @param b string with binary number
 * @param n number of bits
 * @return integer number from string b
 */
int abtoi(const char* b, unsigned n);

#endif /* WLCSTDLIB_H_ */

