#ifndef MAINFORM_H
#define MAINFORM_H

#include <QtCore/QtCore>

#include "sccommon.h"

#include "ui_mainform.h"
#include "transform.h"
#include "raportform.h"

class MainForm: public QMainWindow
{
	Q_OBJECT

public:
	MainForm();

public slots:
	void makeTrans();
	void generateRaport();
	void manual();
	void aboutSCm();
	
	void yearOrMonthChanged();
	void dayChanged( int , int );
	void deleteData();
	
	void addWorkerToPlan( int row, int col );
	void savePlan();
	void cleanPlan();
	void getClipboard();
	void setClipboard();

	void addWorker();
	void delWorker();

	void refreshStatuss();

	void refreshWls();
	void refreshWorkers();
	void refreshPlan();

	void endDeleteData( int exitCode,
		QProcess::ExitStatus exitStatus );

	void endRefreshWls( int exitCode,
		QProcess::ExitStatus exitStatus );
		
	void endRefreshWorkers( int exitCode,
		QProcess::ExitStatus exitStatus );
		
	void endRefreshPlan( int exitCode,
		QProcess::ExitStatus exitStatus );

	void endSavePlan( int exitCode,
		QProcess::ExitStatus exitStatus );

	void endAddWorker( int exitCode,
		QProcess::ExitStatus exitStatus );
	void endDelWorker( int exitCode,
		QProcess::ExitStatus exitStatus );

private:
	Ui::MainForm ui;
	static const QString SCmanagerCmd;
	QProcess	SCmanager_wr_add,
			SCmanager_wr_del,
			SCmanager_wr_ref,
			SCmanager_ws_save,
			SCmanager_ws_ref,
			SCmanager_wl_ref,
			SCmanager_wl_del;
	const QIcon check, nocheck;
	bool planEdited;
	QDate calendarDate;
	int daySelection;
	static const int shifts_num = 3;
	QString clipboard[SCS_NUMB_MAX][shifts_num];
	QTimer statusTimer;
	enum mainGrps
	{
		calendarGrp,
		planGrp,
		workersGrp,
		mainGrpsNumb
	};
	int grpsBlock[mainGrpsNumb];

	void blockGroup( mainGrps grp );
	void unblockGroup( mainGrps grp );

	void connectYearOrMonthChanged();
	void disconnectYearOrMonthChanged();

	bool checkIfRestorePlan();
};

#endif
