#include "scdata_l.h"

int 	SCr_not_loged = 0,
	SCr_max_not_loged = 10;

const char* SCr_proclog_dir = "proclogs/";

int SCr_proc_log_on = 1;

int SCr_new_wl(const char* strdate)
{
	char wl_path[100];
	FILE* wl;

	sprintf(wl_path, "%s/%s.wl", SC_worklogs_dir, strdate);
	wl = fopen(wl_path, "r");
	if(!wl)
	{
		wl = fopen(wl_path, "a");
		if(wl)
		{
			fclose(wl);
			return SCr_wl_state_new;
		}
		else
			return SCr_wl_state_err;
	}
	else
	{
		fclose(wl);
		return SCr_wl_state_old;
	}
}

char* SCr_user_to_str(int type)
{
	switch(type)
	{
		case SCr_user_trans_start : return "Transfer start";
		case SCr_user_trans_end : return "Transfer end";
		case SCr_user_sys_off : return "SC system OFF";
		case SCr_user_sys_on : return "SC system ON";
	}

	return "nieznany";
}

void SCr_log_proc(int proc, int codeA, int codeB, const char* strdate)
{
	char str_time[10];
	scode_time(str_time, time(NULL));
	char act_log[SCR_MAX_LINE];
	
	switch(proc)
	{
		case SCr_proc_data : sprintf(act_log, "%s DATA:\tcode:%u\tinput:%s",
			str_time, codeA, itoab(codeB, INBITS)); break;
		case SCr_proc_user : sprintf(act_log, "%s USER:\t%s",
			str_time, SCr_user_to_str(codeA)); break;
		case SCr_proc_error : sprintf(act_log, "%s ERROR:\ttype:%s\tcode:%u",
			str_time, SCr_err_to_str(codeA), codeB);
	}
	puts(act_log);
	fflush(stdout);
	
	if(SCr_proc_log_on)
	{
		FILE* proclog;
		char proclog_path[30];
		sprintf(proclog_path, "%s/%s.pl", SCr_proclog_dir, strdate);
		proclog = fopen(proclog_path, "a");

		if(proclog)
		{
			fputs(act_log, proclog);
			fputc('\n', proclog);
			fclose(proclog);
		}
	}
}

void SCr_log_error(int type, int code, const char* strdate)
{
	FILE* errorlog = fopen(SC_errorlog_name, "a");
	
	struct SCr_errno err;
	err.time = time(NULL);
	err.type = type;
	err.code = code;
	
	SCr_err_fwrite(errorlog, &err);
	SCr_log_proc(SCr_proc_error, type, code, strdate);

	fclose(errorlog);
}

int SCr_log_data(const struct SCs_data* unloged, const char* strdate)
{
	char worklog_path[100];
	sprintf(worklog_path, "%s/%s.wl", SC_worklogs_dir, strdate);
	
	FILE *worklog = fopen(worklog_path, "a");
	if(!worklog)
	{
		SCr_not_loged += 1;
		return 0;
	}
	else
	{
		SCs_data_fwrite(worklog, unloged);
		fclose(worklog);
		SCr_log_proc(SCr_proc_data, unloged->code, unloged->input, strdate);
	}
	
	return 1;
}

