/*
 * Prosty program do testowania modulow SCslave
 */

#include <stdlib.h>
#include <stdio.h>

#include "work/schard.h"

#include "wlcstdc.h"

int main(int argc, char** argv)
{
	int input;
	
	if( argc < 2 )
	{
		puts("Zla liczba argumentow");
		return 1;
	}

	puts("Inicjalizacja hardeware'u");
	if( SC_hard_init() != 0 )
	{
		puts("Blad podczas inicializacji hardware'u");
		return 2;
	}

	puts("Inicjalizacja SCslave");
	if( SCs_init( argv[1], 1 ) != 0 )
	{
		puts("Blad podczas inicjalizacji SCslave");
		return 3;
	}

	while(1)
	{
		puts("Pobieranie danych");
		input = SCs_data_cycle( 1 );
		switch( input )
		{
			case -1 : puts("Brak nowych danych"); break;
			case -2 : puts("Blad podczas komunikacji"); break;
			default : printf("input: %s\n", itoab( input, 16 ) );
		};
		sleep(1);
	}

	return 0;
}

