/*
 * scwl2dir - scrunners subprogram used to transfer its data
 * to a transfer directory
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include <sys/wait.h> 

#include "scdata.h"

#include "wlcstdc.h"

int make_transfer(const char* tr_mp)
{
	#define SB 100
	long sizer;
	char 	*oldwlset_name = "oldwl.set",
		terror_dir[SB],
		wl_trans_dir[SB], wl_stat_dir[SB],
		wl_date[DATELEN+1], strb[SB];
	FILE 	*oldwlset, *wlset, *trwlset,
		*wl_stat,
		*md5sum,
		*terror;
	unsigned char md5digets[MD5LEN];
	
	strcpy(strb, tr_mp);
	trwlset = fopen(strcat(strb, "/wl.set"), "r");
	if(trwlset)
	{
		fclose(trwlset);
		remove(terror_dir);
		return SCt_err_over;
	}

	strcpy(terror_dir, tr_mp);
	strcat(terror_dir, "/terror");
	terror = fopen(terror_dir, "w");
	if(!terror)
		return SCt_err_no_terr;
	else
		fclose(terror);

	strcpy(strb, tr_mp);	
	trwlset = fopen(strcat(strb, "/wl.set"), "w");
	strcpy(strb, tr_mp);
	mkdir(strcat(strb, "/worklogs"));
	if(!trwlset)
		return SCt_err_no_twlset;
		
	copy(SC_wlset_name, oldwlset_name);
	oldwlset = fopen(oldwlset_name, "r");
	if(!oldwlset)
	{
		fclose(trwlset);
		remove(oldwlset_name);
		return SCt_err_no_owlset;
	}
	wlset = fopen(SC_wlset_name, "w");
	if(!wlset)
	{
		fclose(oldwlset);
		fclose(trwlset);
		rename(oldwlset_name, SC_wlset_name);
		return SCt_err_no_wlset;
	}

	sizer = 0;
	while(!feof(oldwlset))
	{
		wl_date[0] = '\0';
		fgets(wl_date, DATELEN + 1, oldwlset);
		if(wl_date[0] == '\0')
			break;
		wl_date[DATELEN-1] = '\0';
		
		sprintf(wl_stat_dir, "worklogs/%s.wl", wl_date);
		sprintf(wl_trans_dir, "%s/worklogs/%s.wl", tr_mp, wl_date);
		if(copy(wl_stat_dir, wl_trans_dir) != 0)
		{
			fputs(wl_date, wlset);
			fputc('\n', wlset);
			break;
		}
		
		wl_stat = fopen(wl_stat_dir, "rb");
		if(wl_stat)
		{
			md5file(wl_stat, md5digets);
			md5sum = fopen(strcat(wl_trans_dir, ".md5"), "wb");
			if(md5sum)
			{
				fwrite(md5digets, sizeof(unsigned char), MD5LEN, md5sum);
				fclose(md5sum);
			}
			fclose(wl_stat);
		}
		wl_date[DATELEN-1] = '\n';
		fputs(wl_date, trwlset);
	}

	if(feof(oldwlset))
	{
		scode_date(wl_date, time(NULL));
		fputs(wl_date, wlset);
		fputc('\n', wlset);
	}
	else
		while(!feof(oldwlset))
		{
			fgets(wl_date, DATELEN + 1, oldwlset);
			fputs(wl_date, wlset);
		}
	
	fclose(oldwlset);
	remove(oldwlset_name);
	fclose(wlset);
	fclose(trwlset);

	sprintf(strb, "%s/%s", tr_mp, SC_errorlog_name);
	if(copy(SC_errorlog_name, strb) == 0)
		remove(SC_errorlog_name);
	
	remove(terror_dir);
	return 0;
}

int main(int argc, char** argv)
{
	int mt_ret, sys_ret;
	char command[120];
	
	if(argc != 2)
	{
		puts("scwl2dir - program transferujacy pliki worklog \
			a katalogu w programu scrunner do okreslonego \
			katalogu transferowego.\n\
			usage:\n\tscwl2dir dir_name\n");
		return SCt_err_argc;
	}

	sprintf(command, "sh pre-trans.sh %s", argv[1]);
	sys_ret = system(command);
	if(!WIFEXITED(sys_ret) || (WEXITSTATUS(sys_ret) != 0))
		return SCt_err_pre_sh;
	 
	mt_ret = make_transfer(argv[1]);
	
	sprintf(command, "sh post-trans.sh %s", argv[1]);
	sys_ret = system(command);

	if(mt_ret != 0)
		return mt_ret;
	if(!WIFEXITED(sys_ret) || (WEXITSTATUS(sys_ret) != 0))
		return SCt_err_pre_sh;

	return 0;
}

